﻿using Dto;
using Entities;
using Model.OrderCriteria;
using Shared;
using Shared.Mapper;

namespace API.Service;

public class UserDataServiceApi(IUserService<UserEntity> userService) : IUserService<UserDto>
{
    public IEnumerable<UserDto> GetUsers(int page, int number, UserOrderCriteria orderCriteria)
    {
        var usersEntities = userService.GetUsers(page, number, orderCriteria);
        return usersEntities.Select(e => e.FromEntityToDto()).ToList();
    }

    public UserDto GetUserById(int id) => userService.GetUserById(id).FromEntityToDto();

    public UserDto GetUserByUsername(string username) => userService.GetUserByUsername(username).FromEntityToDto();

    public bool DeleteUser(int id) => userService.DeleteUser(id);

    public UserDto UpdateUser(int id, UserDto user) =>
        userService.UpdateUser(id, user.FromDtoToEntity()).FromEntityToDto();

    public UserDto CreateUser(string username, string password, string email, bool isAdmin) =>
        userService.CreateUser(username, password, email, isAdmin).FromEntityToDto();
}