﻿namespace Dto;

public class LessonDto : IEquatable<LessonDto>
{
    public int Id { get; }
    public string Title { get; set; }
    public string LastPublisher { get; set; }
    public DateOnly LastEdit { get; set; }
    public ICollection<ContentLessonDto> Content { get; set; } = new List<ContentLessonDto>();

    public LessonDto()
    {
    }

    public LessonDto(int id, string title, string lastPublisher, DateOnly lastEdit)
    {
        Id = id;
        Title = title;
        LastPublisher = lastPublisher;
        LastEdit = lastEdit;
    }

    public LessonDto(string title, string lastPublisher, DateOnly lastEdit)
    {
        Title = title;
        LastPublisher = lastPublisher;
        LastEdit = lastEdit;
    }

    public override string ToString()
    {
        return $"{Id}\t{Title}\t{LastPublisher}\t{LastEdit}";
    }

    public override bool Equals(object right)
    {
        if (object.ReferenceEquals(right, null))
        {
            return false;
        }

        if (object.ReferenceEquals(this, right))
        {
            return true;
        }

        if (this.GetType() != right.GetType())
        {
            return false;
        }

        return this.Equals(right as LessonDto);
    }

    public bool Equals(LessonDto other)
    {
        return (this.Id == other.Id);
    }

    public override int GetHashCode()
    {
        return Id;
    }
}