﻿namespace Dto;

public class ParagraphDto : ContentLessonDto, IEquatable<ParagraphDto>
{
    public string Title { get; set; }
    public string Content { get; set; }
    public string Info { get; set; }
    public string Query { get; set; }
    public string Comment { get; set; }

    public ParagraphDto(string title, string content, string info, string query, string comment, int lessonId) :
        base(content,
            title, lessonId)
    {
        Title = title;
        Content = content;
        Info = info;
        Query = query;
        Comment = comment;
    }

    public ParagraphDto(int id, string title, string content, string info, string query, string comment, int lessonId) :
        base(id, content,
            title, lessonId)
    {
        Id = id;
        Title = title;
        Content = content;
        Info = info;
        Query = query;
        Comment = comment;
    }

    public ParagraphDto() : base()
    {
    }

    public override string ToString()
    {
        return $"{Id}\t{Title}\t{Content}\t{Info}\t{Query}\t{Comment}";
    }

    public override bool Equals(object right)
    {
        if (object.ReferenceEquals(right, null))
        {
            return false;
        }

        if (object.ReferenceEquals(this, right))
        {
            return true;
        }

        if (this.GetType() != right.GetType())
        {
            return false;
        }

        return this.Equals(right as ParagraphDto);
    }

    public bool Equals(ParagraphDto other)
    {
        return (this.Id == other.Id);
    }

    public override int GetHashCode()
    {
        return Id;
    }
}