﻿using Model.OrderCriteria;

namespace Shared
{
    public interface IParagraphService<TParagraph>
    {
        public IEnumerable<TParagraph> GetParagraphs(int page, int number, ParagraphOrderCriteria orderCriteria);
        public TParagraph GetParagraphById(int id);
        public TParagraph GetParagraphByTitle(string title);
        public bool DeleteParagraph(int id);
        public TParagraph UpdateParagraph(int id, TParagraph paragraph);

        public TParagraph CreateParagraph(string title, string content, string info, string query, string comment,
            int lessonId);
    }
}