﻿using Model.OrderCriteria;

namespace Shared
{
    public interface IUserService<TUser>
    {
        public IEnumerable<TUser> GetUsers(int page, int number, UserOrderCriteria orderCriteria);
        public TUser GetUserById(int id);
        public TUser GetUserByUsername(string username);
        public bool DeleteUser(int id);
        public TUser UpdateUser(int id, TUser user);
        public TUser CreateUser(string username, string password, string email, bool isAdmin);
    }
}